/*
 *  ScrapMemo
 *
 *  Copyright (c) 2005, Kyosuke Takayama <support at mc.neweb.ne.jp>
 *  http://espion.just-size.jp/
 *
 *  $Id: smemo.js 11 2005-10-07 01:38:07Z takayama $
*/

var DIR = { "DATA":'./memo', "BACKUP":'./backup' };
var util;

if(typeof(SCM) == 'undefined') var SCM = {}

// TODO グローバル変数をなんとか汁
// SCM.edit

// 初期化
SCM.init = function() {
   // オブジェクト初期化 とか
   {
      // ユーティリティ読み込み
      util = new Util;
      //scm  = new SCM;
      document.onmousedown = function(e) { util.Mdown(e) };

      // suggest フォームセッティング
      new SCM.suggest(
            document.sForm.search,
            makeList,
            SCM.load.doSearch
      );
   }

   // 初期データロード
   {
      scroller.flag = 1;
      SCM.load.listSearch();
      SCM.load.listTag();

      var ins = (window.location.hash && window.location.hash != "#") ?
      (window.location.hash.substr(1)) : '1000000001';

      var query = (window.location.search && window.location.search != "?") ?
      (window.location.search.substr(1)) : '';

      SCM.load.listIndex();
      if(ins.match(/^[\d,]+$/) && !query) {
         SCM.load.insert(ins);
      } else {
         SCM.load.search(query||ins);
      }
      SCM.load.menu();

      scroller.flag = 0;
   }

}

// xmlHTTP 実行
SCM.execHttp = {
   fListHash: { "div":"flist", "index":"smemoindex",  "item":"smemo", "create":"index" },
   sListHash: { "div":"slist", "index":"smemosearch", "item":"item",  "create":"search" },
   tListHash: { "div":"slist", "index":"smemotags",   "item":"tags",  "create":"tag" },
   xmllist:   DIR['DATA']+"/list.xml",
   xmlsearch: DIR['DATA']+"/search.xml",
   xmltag:    DIR['DATA']+"/taglist.xml",
   xmlcgi:    "./smemo.cgi",

   _loadList: function(file, hash) {
      var xmlhttp = new AJAX.init(file);
      xmlhttp.load = new SCM.parseList(xmlhttp, hash);
      xmlhttp.get();
   },

   doSearch: function(word) {
      SCM.param.set('lasthist', word);
      var encWord = encodeURIComponent(word);
      var xmlhttp = new AJAX.init(this.xmlcgi+"?q="+encWord);
      xmlhttp.load = new SCM.parseSearch(xmlhttp, word);
      xmlhttp.get();
   },

   loadIndex: function() {
      this._loadList(this.xmllist, this.fListHash);
   },

   loadSearch: function() {
      this._loadList(this.xmlsearch, this.sListHash);
   },

   loadTag: function() {
      this._loadList(this.xmltag, this.tListHash);
   },

   loadSmemo:  function(name, div) {
      var xmlhttp = new AJAX.init(DIR['DATA']+"/"+name+".xml");
      xmlhttp.load = new SCM.parseSmemo(xmlhttp, div, name);
      xmlhttp.get();
   },

   loadEdit: function(name, e) {
      var xmlhttp = new AJAX.init(this.xmlcgi);
      xmlhttp.load = new SCM.parseSmemo(xmlhttp, 'smemoAdd' + name, name, e);

      var data = '';
      var body = util.postEscape(document.update.smemo.value);
      var tags = util.postEscape(document.update.tags.value);

      data = data.concat('name='+name+'&');
      data = data.concat('tags='+tags+'&');
      data = data.concat('body='+body);

      xmlhttp.post(data);
   },

   loadDelsearch: function(word) {
      if(!word) return;
      word = encodeURIComponent(word);
      var xmlhttp = new AJAX.init(this.xmlcgi+'?dq='+word);
      xmlhttp.load = new SCM.parseList(xmlhttp, this.sListHash);
      xmlhttp.get();
   }
}

SCM.execHttp.fListHash['exec'] = function() {
   SCM.param.clear('index_subj');
   SCM.param.clear('index_subjToName');

   var index = SCM.param.get('index');

   var idx = new Array;
   if(index&&index[0]) {
      var href = new Array;
      for(var i in index) {
         var subj = index[i]['subject']||'untitled';
         if(idx[subj.toLowerCase()]) {
            idx[subj.toLowerCase()] += ','+index[i]['name'];
         } else {
            idx[subj.toLowerCase()] = index[i]['name'];
            SCM.param.add('index_subj', subj);
         }
      }
      SCM.param.set('index_subjToName', idx);
   }
}

SCM.execHttp.tListHash['exec'] = function() {

   document.getElementById('tag').className = 'now';
   document.getElementById('his').className = '';
   insert(document.update.taglist);

   function insert(theForm) {
      var tag = SCM.param.get('tag');

      /*
      util.clearElement('tags');
      var elm    = document.getElementById('tags');

      for(var i in tag) {
         elm.appendChild(_pushLink(tag[i]));
         if(i == 7) break;
      }
      */

      theForm.options.length = tag.length+1;

      theForm.options[0].value = '';
      theForm.options[0].text  = '-';

      for(var i in tag.sort()) {
         theForm.options[(parseInt(i)+1)].value = tag[i];
         theForm.options[(parseInt(i)+1)].text  = tag[i];
      }
   }

   function _pushLink(tag) {
      var aClick = function(){ document.update.tags.value += tag+' '; };
      return util.createLink(tag, aClick);
   }
}

SCM.execHttp.sListHash['exec'] = function() {
   var search = SCM.param.get('search');
   SCM.param.set('search', search.sort().reverse());
   document.getElementById('tag').className = '';
   document.getElementById('his').className = 'now';
}

SCM.load = {
   list: new Array,

   create: function() {
      var time = (new Date()).getTime();
      document.update.smemo.value  = '';
      document.update.tags.value   = '';
      document.update.stop.checked = true;

      util.clearElement('editPreview');

      var add = 'smemoAdd' + time;
      var elm = document.getElementById('asmemo');
      var div = document.createElement("div");
      div.setAttribute('id', add);
      elm.insertBefore(div, elm.firstChild);

      SCM.edit = new SCM.editSmemo(time);
   },

   menu: function() {
      SCM.execHttp.loadSmemo(1000000000, 'amenu');
   },

   perma:  function(num) {
      util.clearElement('asmemo');
      this.insert(num);
   },

   insert: function(num, ins) {
      num += ',';

      var nums = num.split(",");
      for(var n in nums) {
         if(nums[n]) this.doInsert(nums[n], ins);
      }
   },

   doInsert: function(num, ins) {
      var add = 'smemoAdd' + num;
      this.load(add, (ins||''));

      SCM.execHttp.loadSmemo(num, add);
   },

   load: function(add, ins) {
      if(ins.match(/1000000000$/)) ins = false;

      var div;
      if(document.getElementById(add)) {
         div = (document.getElementById(add));
      } else {
         var elm = document.getElementById('asmemo');
         var div = document.createElement("div");
         div.setAttribute('id', add);

         var newList = new Array();
         var next=0;
         for(var i in this.list) {
            if(ins) {
               if(next == -1) {
                  next = this.list[i];
                  newList.push(add);
               } else if(this.list[i] == ins) {
                  next = -1;
               }
            }
            newList.push(this.list[i]);
         }

         if(ins) {
            next = document.getElementById(next);
            if(next) {
               elm.insertBefore(div, next);
            } else {
               elm.appendChild(div);
               newList.push(add);
            }
         } else {
            elm.insertBefore(div, elm.firstChild);
            newList.unshift(add);
         }
         this.list = newList;
      }
      scroller.set(div.offsetTop, add);

      return div;
   },

   close: function(div) {
      navi.close();
      document.getElementById('asmemo').removeChild(document.getElementById(div));

      var newList = new Array();
      for(var i in this.list) {
         if(this.list[i] == div) continue;
         newList.push(this.list[i]);
      }
      this.list = newList;
   },

   allclose: function() {
      util.clearElement('asmemo');
   },

   newEdit: function(num) {
      SCM.execHttp.loadSmemo(num, 'editPreview');
   },

   edit: function(name) {
      SCM.execHttp.loadEdit(name, 1);
   },

   // 検索関連
   search: function(word, ins) {
      document.sForm.search.value = word;
      this.doSearch('', ins);
   },

   doSearch: function(obj, ins) {
      var word = document.sForm.search.value;
      document.sForm.search.value = (word||'');

      var add = 'ssmemo'+encodeURIComponent(word);
      if(ins) ins=ins+'';
      if(ins&&!ins.match(/^ssmemo/)) ins = 'smemoAdd'+ins;
      SCM.load.load(add, ins||'');
      SCM.createSearch(word);

      SCM.execHttp.doSearch(word);

      return false;
   },

   delSearch: function(word) {
      SCM.execHttp.loadDelsearch(word);
   },

   eventSearch: function(word, ins) {
      return function() {
         SCM.load.search(word, ins);
      }
   },

   // リスト関連
   listIndex: function() {
      SCM.execHttp.loadIndex();
   },

   listSearch: function() {
      SCM.execHttp.loadSearch();
   },

   listTag: function() {
      SCM.execHttp.loadTag();
   }
}

SCM.createList = {
   index: function(num, hash) {
      SCM.param.add('index', hash);
      var title = hash['subject']||'untitled';
      var li = util.createElm('li', 'list');
      li.setAttribute('id', 'list'+hash["name"]);

      var aClick = function(){ selList.set(hash["name"]); };
      var link   = util.createLink(title, aClick, '#'+hash["name"]);
      li.appendChild(link);

      var date = ' ('+hash['date'].substring(11,16)+')';
      li.appendChild(document.createTextNode(date));

      return li;
   },

   newIndex: function(num, hash, ins) {
      var li = document.createElement('li');

      var aClick = function(){ SCM.load.insert(hash["name"], ins); };

      var date = '['+hash['date'].substring(0,10)+'] ';
      li.appendChild(document.createTextNode(date));

      var link   = util.createLink(hash['subject']||'untitled', aClick, '#'+hash["name"]);
      li.appendChild(link);

      return li;
   },

   list: function(num, word, count) {
      var li = util.createElm('li', 'list');
      li.setAttribute('id', 'lists'+num);

      var name = word;
      var aClick = function(){ selList.set("s"+num, word); };
      if(count) name +=  ' (' + count + ')';
      li.appendChild(util.createLink(name, aClick));

      return li;
   },

   search: function(num, word) {
      SCM.param.add('search', word);
      var li = this.list(num, word);

      var span = util.createElm('span', 'del');
      span.appendChild(document.createTextNode(' : '));
      var aDel = function(){ SCM.load.delSearch(word); };
      span.appendChild(util.createLink('del', aDel));
      li.appendChild(span);

      return li;
   },

   tag: function(num, hash) {
      SCM.param.add('tag', hash['tag']);
      return this.list(num, 'tag:'+hash['tag'], hash['count']);
   }
}

SCM.createSmemo = function(div, hash) {
   var data = hash["body"];

   var day  = util.createElm('div', 'day');
   var body = util.createElm('div', 'body');
   var sec  = util.createElm('div', 'section');

   if(div == 'editPreview') {
      data = hash['subject'] + "\n" + data;
   } else {
      var aClk = function(){ navi.show(div, hash['name']); };
      util.addEvent(sec, 'click', aClk);

      if(div != 'amenu') {
         var nav = createNav(div, hash['name']);
         sec.appendChild(nav);

         var span  = util.createElm('span', 'title');
         span.appendChild(document.createTextNode(hash['subject']));
         var subject = document.createElement('h2');
         subject.appendChild(span);

         var number = util.createElm('span', 'number');
         number.appendChild(document.createTextNode(':'+hash['name']));
         subject.appendChild(number);
         subject.appendChild(document.createTextNode(' '));

         var taglist = util.createElm('span', 'taganchor');
         for(var i in hash['tags']) {
            var word = 'tag:'+hash['tags'][i];
            var aClick = new SCM.load.eventSearch(word, hash['name']);

            taglist.appendChild(document.createTextNode('['));
            taglist.appendChild(util.createLink(hash['tags'][i], aClick));
            taglist.appendChild(document.createTextNode(']'));
         }
         subject.appendChild(taglist);

         day.appendChild(subject);

         data += "\n\n";
         data += "update:"+hash["date"];
         data += " (since:"+hash["create"]+")\n\n";

         // バックアップ関連
         {
            var bDiv = util.createElm('div', 'bmenu');
            var bList = document.createElement("ul");
            bDiv.setAttribute('id', 'bm'+hash["name"]);
            bDiv.appendChild(document.createTextNode('Backups:'));
            for(var x in hash['backups']) {
               var bLi = util.createElm('li', 'list');
               bLi.appendChild(util.createLink(hash['backups'][x], '', DIR['BACKUP']+'/'+hash["name"]+'.bak'+(parseInt(x)+1)+'.xml'));
               bList.appendChild(bLi);
            }
            bDiv.appendChild(bList);

            var aBcl = function(){ bNavi.close('bm'+hash['name']); } ;
            util.addEvent(bDiv, 'click', aBcl);
         }

         day.appendChild(bDiv);
      }
   }

   data = data.replace(/(\r\n|\r|\n){3,}/g, "\n\n").replace(/^\n{1,}/, "").replace(/\n{1,}$/, "");

   if(data) sec.appendChild(pjswlf.doMarkup(data, hash['name']));

   body.appendChild(sec);
   day.appendChild(body);

   util.clearElement(div);
   document.getElementById(div).appendChild(day);
}

SCM.createEditPreview = function(hash) {
   document.update.smemo.value  = hash['subject']+"\n"+hash['body'];
   document.update.tags.value   = (hash['tags']) ? hash['tags'].join(' ')+' ' : '';
   document.update.stop.checked = false;
   this.edit = new this.editSmemo(hash['name']);
}

SCM.createSearch = function(word) {
   var elm = 'ssmemo'+encodeURIComponent(word);
   util.clearElement(elm);

   var div  = document.getElementById(elm);
   var srh  = util.createElm('div', 'search');
   var day  = util.createElm('div', 'day');
   var body = util.createElm('div', 'body');
   var sec  = util.createElm('div', 'section');
   var span = util.createElm('span', 'title');
   var subject = util.createElm('h2', 'sTitle');

   sec.setAttribute('id', 'smemoSearch'+encodeURIComponent(word));

   span.appendChild(document.createTextNode('search for ['+word+']'));
   subject.appendChild(span);
   day.appendChild(subject);

   sec.appendChild(util.createLoading());

   body.appendChild(sec);
   day.appendChild(body);
   srh.appendChild(day);
   div.appendChild(srh);
}

SCM.param = {
   list: new Array(),

   set: function(key, data) {
      this.list[key] = data;
   },

   get: function(key, param) {
      return (param) ? this.list[key][param] : this.list[key];
   },

   add: function(key, data) {
      this.list[key].push(data);
   },

   clear: function(key) {
      this.list[key] = new Array();
   }
}


// new して読む

SCM.parseSmemo = function(xmlhttp, div, name, e) {
   return function() {
      var response = xmlhttp.getResponse();
      if(!response) return;
      var smemoNode = response.getElementsByTagName("smemo");
      if(!smemoNode || !smemoNode.length) return;

      if(div == 'editPreview') SCM.createEditPreview(createXmlHash.exec('smemo', smemoNode[0]));
      SCM.createSmemo(div, createXmlHash.exec('smemo', smemoNode[0]));

      if(e) {
         document.update.save.disabled = true;
         document.update.save.value = 'save';
      }
   }
}

SCM.parseSearch = function(xmlhttp, word) {
   return function() {
      var response = xmlhttp.getResponse();
      if(!response) return;

      var elm = 'smemoSearch'+encodeURIComponent(word);
      util.clearElement(elm);

      var indexNode = response.getElementsByTagName("smemoindex");
      if(!indexNode || !indexNode.length) { util.insertNotFound(elm); return; }

      var node = indexNode[0].getElementsByTagName("smemo");
      var tags = indexNode[0].getElementsByTagName("tags");

      var search = new makeSearchLink(encodeURIComponent(word), node , tags);
      search.make(0);
   }
}

function makeSearchLink(eword, list, tags) {
   var elm = 'smemoSearch'+eword;

   this.make = function(z) {
      util.clearElement(elm);

      var ul = util.createElm('ul', 'search');

      start = z * 10;
      this.url = new Array;
      for(var i=start;i <= start+9;i++) {
         if(list[i]) {
            var hash = createXmlHash.exec('index', list[i]);
            li = SCM.createList['newIndex'](i, hash, 'ssmemo'+eword);
            ul.appendChild(li);
            this.url.push(hash['name']);
         } else if(start > 0) {
            li = document.createElement('li');
            li.appendChild(document.createTextNode('x'));
            ul.appendChild(li);
         }
      }

      document.getElementById(elm).appendChild(this.tagLink());
      document.getElementById(elm).appendChild(this.createNav());
      document.getElementById(elm).appendChild(ul);

      if(!list || !list.length) util.insertNotFound(elm);

      var pageNum = parseInt((list.length-1)/10);
      if(pageNum > 0) {
         var page = util.createElm('div', 'pagelink');
         for(var i=0;i <= pageNum;i++) {
            var link = pushLink(i);
            if(i == z) link.className = 'select';
            page.appendChild(link);
         }
         document.getElementById(elm).appendChild(page);
      }

      var _this = this;
      function pushLink (z) {
         var aLink = function() { _this.make(z); };

         return util.createLink(z+1, aLink);
      }
   }


   this.createNav = function() {
      var nav = util.createElm('div', 'nav');

      var aClose = function(){ SCM.load.close('ssmemo'+eword); };
      nav.appendChild(util.createLink('close', aClose));

      var _url = this.url.reverse().join(',');
      var aChain = function(){ SCM.load.insert(_url, 'ssmemo'+eword); };
      nav.appendChild(util.createLink('chain', aChain));

      var aTag = function(){ bNavi.show('ss'+eword); };
      if(this.tagDisabled) {
         var del = document.createElement('del');
         del.appendChild(util.createLink('tags', aTag));
         nav.appendChild(del);
      } else {
         nav.appendChild(util.createLink('tags', aTag));
      }

      return nav;
   }

   this.tagLink = function() {
      var div = util.createElm('div', 'taglink');
      div.appendChild(document.createTextNode('Related tags:'));
      div.setAttribute('id', 'ss'+eword);

      this.tagDisabled = true;
      if(tags.length > 0) {
         var ul  = document.createElement("ul");
         var tag = tags[0].getElementsByTagName('tag');

         for(var i=0;i < tag.length;i++) {
            var tLi = util.createElm('li', 'list');
            tLi.appendChild(pushTagLink(tag[i].firstChild.data));
            ul.appendChild(tLi);
         }

         div.appendChild(ul);
         if(tag.length > 0) this.tagDisabled = false;
      }

      var aTcl = function(){ bNavi.close('ss'+eword); };
      util.addEvent(div, 'click', aTcl);
      return div;

      function pushTagLink(t) {
         var aLink = function(){ SCM.load.search('tag:'+t, 'ssmemo'+eword) };
         return util.createLink(t, aLink);
      }
   }
}

/*
var time = (new Date()).getTime();
var done = (new Date()).getTime();
alert(done - time);
*/

SCM.parseList = function(xmlhttp, lHash) {
   return function() {
      var response = xmlhttp.getResponse();
      if(!response) return;

      util.clearElement(lHash['div']);

      var indexNode = response.getElementsByTagName(lHash['index']);
      if(!indexNode || !indexNode.length) { util.insertNotFound(lHash['div']); return; }
      var smemoNode = indexNode[0].getElementsByTagName(lHash['item']);
      if(!smemoNode || !smemoNode.length) { util.insertNotFound(lHash['div']); return; }

      var tmpUpdate;
      var list = document.createElement('ol');
      var div  = document.getElementById(lHash['div']);

      SCM.param.clear([lHash['create']]);

      for(var i=0;i < smemoNode.length;i++) {
         var hash = createXmlHash.exec(lHash['create'], smemoNode[i]);

         if(hash["date"]) {
            var update = hash["date"].split('T');
            if(update[0] != tmpUpdate) {
               var add = document.createElement('strong');
               add.appendChild(document.createTextNode(update[0]));
               if(tmpUpdate) div.appendChild(list);
               div.appendChild(add);

               list = document.createElement('ul');
               div  = document.getElementById(lHash['div']);
               tmpUpdate = update[0];
            }
         }

         list.appendChild(SCM.createList[lHash['create']](i, hash));
      }

      div.appendChild(list);

      if(lHash['exec']) lHash['exec']();

   }

   // TODO DOMへ
   function insertHTML(val) {
      document.getElementById(lHash['div']).innerHTML = '<ul>'+val+'</ul>';
   }
}


SCM.editSmemo = function(name) {
   if(SCM.edit) SCM.edit.clear();
   navi.close();

   var count = 0;
   var timer = window.setInterval("SCM.edit.refresh()", 750);

   document.update.save.disabled = true;
   util.setLayer('smemoEdit', 0, util.winY());

   var oldRefresh = new relCheck;
   var oldUpdate  = new relCheck;

   var form = document.update;

   var oldBody    = form.smemo.value;
   var oldTags    = form.tags.value;

   var timerstop  = 0;

   this.clear = function() {
      clearInterval(timer);
   }

   this.refresh = function() {
      if(!timerstop && count ++ && count > 4 && this.update()) count = 0;
      if(count % 2 == 0) {
         if(!oldRefresh.exec()) return;
         var hash = [];
         hash['body'] = form.smemo.value;
         hash['name'] = name;
         hash['subject'] = '';
         SCM.createSmemo('editPreview', hash);

         if(oldUpdate.exec(1)) document.update.save.disabled = false; 
      }
      count = 3;
   }

   this.revert = function() {
      form.smemo.value = oldBody;
      form.tags.value  = oldTags;
   }

   this.update = function() {
      if(!form.stop.checked && oldUpdate.exec()) this.sendupdate();
      return true;
   }

   this.save  = function() {
      if(oldUpdate.exec()) this.sendupdate();
   }

   this.sendupdate = function() {
      document.update.save.value = 'saving...';
      SCM.load.edit(name);
      count = 0;
   }

   this.close = function() {
      if(oldUpdate.exec(1)) {
         timerstop = 1;
         if(!confirm('保存しないで閉じますか?')) {
            timerstop = 0;
            return;
         }
      }
      SCM.edit.finish();
   }

   this.finish = function() {
      document.getElementById('smemoEdit').style.display = 'none';
      SCM.edit.clear();
      SCM.edit = '';
   }

   function relCheck() {
      var oldBody  = document.update.smemo.value;
      var oldTags  = document.update.tags.value;

      this.exec = function(f) {
         var body = document.update.smemo.value;
         var tags = document.update.tags.value;
         if(body == oldBody && tags == oldTags) return false;
         if(!f) {
            oldBody = body;
            oldTags = tags;
         }
         return true;
      }
   }
}



// TODO SCM に入れるか検討
// 独立系
function selTag(theForm) {
   if(theForm.taglist.selectedIndex == 0) return;
   theForm.tags.value += theForm.taglist.options[theForm.taglist.selectedIndex].value + ' ';
   theForm.taglist.options[0].selected = true;
}

function makeList(val) {
   function _match(v, w) {
      v = v.replace(/\\/g, '');
      var reg = new RegExp(v, "i");
      return (w.match(reg));
   }

   var lists = new Array();
   var search = SCM.param.get('search');
   var tag    = SCM.param.get('tag');

   for(var i in search) { if(_match(val, search[i]))     { lists.push(search[i]);     }}
   for(var i in tag)    { if(_match(val, 'tag:'+tag[i])) { lists.push('tag:'+tag[i]); }}

   return lists;
}


var popup = function(elm) {
   this.show = function(app) {
      util.setLayer(elm, util.mx-80, util.my-30);
      if(app) document.getElementById(elm).appendChild(app);
   }

   this.close = function() {
      if(document.getElementById(elm)) document.getElementById(elm).style.display = 'none';
   }
}

var navi = {
   popup: new popup('menu'),
   flag: 0,

   show: function(div, num) {
      if(this.flag) clearTimeout(this.flag);
      util.clearElement('menu');
      this.popup.show(createNav(div, num));
      var _this = this;
      this.flag  = setTimeout(function() { _this.close(); }, 1500);
   },

   close: function() {
      this.popup.close();
   }
}

// バックアップリンク
var bNavi = {
   popup: new Array(),
   flag:  new Array(),

   show: function(num) {
      if(this.flag[num]) clearTimeout(this.flag[num]);
      if(!this.popup[num]) this.popup[num] = new popup(num);
      this.popup[num].show();
      var _this = this;
      this.flag[num] = setTimeout(function() { _this.close(num);}, 4000);
   },

   close: function(num) {
      this.popup[num].close();
   }
}

var selList = {
   lstSel: 0,

   clear: function(div) {
      if(this.lstSel && document.getElementById(this.lstSel)) document.getElementById(this.lstSel).className = '';
   },

   set: function(div, word) {
      this.clear();
      if(word) SCM.load.search(word);
      else SCM.load.insert(div)

      div = 'list'+div;
      this.lstSel = div;
      document.getElementById(div).className = 'flush';
   }
}


var createNav = function(div, num) {
   var nav = util.createElm('div', 'nav');

   if(div.indexOf('Add') >= 0) {
      var aClose = function(){ SCM.load.close(div); };
      nav.appendChild(util.createLink('close', aClose));
   }

   var aEdit = function(){ SCM.load.newEdit(num); };
   nav.appendChild(util.createLink('edit',  aEdit));

   var aPerma = function(){ SCM.load.perma(num); };
   nav.appendChild(util.createLink('permalink',  aPerma, '#'+num));

   var aBup = function(){ bNavi.show('bm'+num); };
   nav.appendChild(util.createLink('backup', aBup));

   nav.appendChild(util.createLink('xml', '', DIR['DATA']+'/'+num+'.xml'));

   return nav;
}



